<!-- #include file="includes/functions.asp" -->
<%
	var methID=Request("id")();
	if (!methID) Response.Redirect('methods.asp');
	var meth=AssignProperties(ExecuteSQL('sp_GetMethod',methID),'name','objID','objName','langID','returnTypeID','returnTypeName','overview','description','returnTypeLangID','returnTypeLangPrefix','isClassMethod');
	SetLanguage(meth.langID);

	var args = IterableFlavor(ExecuteSQL('sp_GetMethodArguments',methID),'id','name','typeID','typeName','reqd','overview','langID','langPrefix');

	var argList = ' ';
	for (var i=0,len=args.length;i<len;i++) argList+=(!args[i].reqd?'<span class="ancillary">[</span>':'')+args[i].name+((i<(len-1))?',':'')+(!args[i].reqd?'<span class="ancillary">]</span>':'')+' ';

	var page='methods';
	var pageTitle='<a href="object.asp?id='+meth.objID+'">'+(meth.isClassMethod?'':'my')+meth.objName+'</a>.'+meth.name+'('+argList+') in '+(langUrl?('<a href="'+langUrl+'" target="external">'+langName+'</a>'):langName)+(Session('admin')?(' <a class="admin" href="admin/method.asp?id='+methID+'">[edit]</a>'):'');
%>
<!-- #include file="includes/header.asp" -->
	<p id="overview">
		<%=meth.overview?meth.overview:('<span class="ancillary">(no overview available)</span>')%>
	</p>

	<h2>Arguments</h2>
		<%
		if (args.length==0) Response.Write('<p class="ancillary">(this method takes no arguments)</p>\n');
		else {
			%>
			<table id="arguments" class="out" cellspacing="0">
				<thead><tr><th>name</th><th>type</th><th class="last">description</th></tr></thead>
				<tbody><%
					for (var i=0,len=args.length;i<len;i++){
						var a=args[i];
						Response.Write('<tr><th>'+a.name+'</th>');
						Response.Write('<td><a href="object.asp?id='+a.typeID+'">'+(a.langID!=meth.langID?a.langPrefix:'')+a.typeName+'</a></td>');
						Response.Write('<td class="last">'+(a.reqd?'':'<span class="ancillary">[optional]</span> ')+(a.overview?a.overview:'')+'&nbsp;</td>');
					}
				%></tbody>
			</table><%
		}
		%>

	<dl>
		<dt>Return Type</dt>
		<dd><%=meth.returnTypeID?('<a href="object.asp?id='+meth.returnTypeID+'">'+(meth.returnTypeLangID!=meth.langID?meth.returnTypeLangPrefix:'')+meth.returnTypeName+'</a>'):'<span class="ancillary">(none)</span>'%></dd>
	</dl>

	<h2>Description</h2>
	<div id="description"><%=meth.description%></div>

<%AddLog(kEvent.pageView,null,meth.langID,meth.objID,null,null,methID)%>
<!-- #include file="includes/footer.asp" -->
