<!-- #include file="includes/functions.asp" -->
<%
	var objID=Request("id")();
	if (!objID) Response.Redirect('objects.asp');
	var obj=AssignProperties(ExecuteSQL('sp_GetObject',objID),'name','langID','overview','description','url');
	SetLanguage(obj.langID);
	var page='objects';
	var pageTitle='Object '+obj.name+' in '+(langUrl?('<a href="'+langUrl+'" target="external">'+langName+'</a>'):langName)+(Session('admin')?(' <a class="admin" href="admin/object.asp?id='+objID+'">[edit]</a>'):'');

	var ancestorObjs=[];
	GetAncestors(objID);
	ancestorObjs.sort(SortByName);

	var descendantObjs=[];
	GetDescendants(objID);
	descendantObjs.sort(SortByName);



	function GetAncestors(oID){
		var parents = IterableFlavor(ExecuteSQL('sp_GetHierParents',oID),'id','name','langID','langPrefix');
		ancestorObjs=ancestorObjs.concat(parents);
		for (var i=0,len=parents.length;i<len;i++) GetAncestors(parents[i].id);
	}

	function GetDescendants(oID){
		var childs = IterableFlavor(ExecuteSQL('sp_GetHierChilds',oID),'id','name','langID','langPrefix');
		descendantObjs=descendantObjs.concat(childs);
		for (var i=0,len=childs.length;i<len;i++) GetDescendants(childs[i].id);
	}

%>
<!-- #include file="includes/header.asp" -->
	<div id="overview">
		<p><%=obj.overview?obj.overview:('<span class="ancillary">(no overview available)</span>')%></p>
		<%
		if (ancestorObjs.length){
			Response.Write('\t\t<p><strong>Inherits from:</strong> ');
			for (var i=0,len=ancestorObjs.length;i<len;i++){
				var o=ancestorObjs[i];
				Response.Write('<a href="object.asp?id='+o.id+'">'+(o.langID!=obj.langID?o.langPrefix:'')+o.name+'</a>'+(i<(len-1)?', ':'</p>\n'));
			}
		}

		if (descendantObjs.length){
			Response.Write('\t\t<p><strong>Inherited by:</strong> ');
			for (var i=0,len=descendantObjs.length;i<len;i++){
				var o=descendantObjs[i];
				Response.Write('<a href="object.asp?id='+o.id+'">'+(o.langID!=obj.langID?o.langPrefix:'')+o.name+'</a>'+(i<(len-1)?', ':'</p>\n'));
			}
		}
		if (obj.url) Response.Write('<p id="url">For official information please see <a href="'+obj.url+'" target="external">'+obj.url+'</a>.</p>');
		%>
	</div>

	<script type="text/javascript" src="<%=approot%>includes/objjob.js"></script>
	<%
		var allProps=[];
		GetProperties(objID,1);
		if (allProps.length){
			%><h2>Class Properties</h2>
			<table id="class_properties" class="out" cellspacing="0">
				<thead><tr><th>name</th><th>type</th><th class="last">description</th></tr></thead>
				<tbody><%
					for (var i=0,len=allProps.length;i<len;i++){
						var p=allProps[i];
						var inherited = (p.objID!=objID);
						Response.Write('<tr'+(inherited?' class="inherited"':'')+'><th><a href="property.asp?id='+p.id+'">'+p.name+'</a></th>');
						Response.Write('<td><a href="object.asp?id='+p.objTypeID+'">'+(p.objTypeLangID!=obj.langID?p.objTypeLangPrefix:'')+p.objTypeName+'</a></td>');
						Response.Write('<td class="last">'+(p.readOnly?'(read only) ':'')+(p.overview?(p.overview+' '):'')+(inherited?('<span class="ancillary">[from <a href="object.asp?id='+p.objID+'">'+(p.langID!=obj.langID?p.langPrefix:'')+p.objName+'</a>]</span>'):'')+'&nbsp;</td>');
					}
				%></tbody>
			</table>
			<%
		}
	
		var allMeths=[];
		GetMethods(objID,1);
		if (allMeths.length){
			%><h2>Class Methods</h2>
			<table id="class_methods" class="out" cellspacing="0">
				<thead><tr><th>name</th><th>returns</th><th class="last">description</th></tr></thead>
				<tbody><%
					for (var i=0,len=allMeths.length;i<len;i++){
						var m=allMeths[i];
						var inherited = (m.objID!=objID);
						Response.Write('<tr'+(inherited?' class="inherited"':'')+'><th><a href="method.asp?id='+m.id+'">'+m.name+'</a></th>');
						Response.Write('<td>'+(m.returnTypeID?('<a href="object.asp?id='+m.returnTypeID+'">'+(m.returnTypeLangID!=obj.langID?m.returnTypeLangPrefix:'')+m.returnTypeName+'</a>'):'<span class="ancillary">(none)</span>')+'</td>');
						Response.Write('<td class="last">'+(m.overview?(m.overview+' '):'')+(inherited?('<span class="ancillary">[from <a href="object.asp?id='+m.objID+'">'+(m.langID!=obj.langID?m.langPrefix:'')+m.objName+'</a>]</span>'):'')+'&nbsp;</td>');
					}
				%></tbody>
			</table>
			<%
		}
	

		if (ancestorObjs.length){
			%><p id="showInheritPara"><input type="checkbox" onclick="ShowInherited(this.checked)" checked id="showInherited"> <label for="showInherited">Show inherited properties/methods?</label></p>
			<%
		}
	
	
		var allProps=[];
		GetProperties(objID,0);
		for (var i=0,len=ancestorObjs.length;i<len;i++) GetProperties(ancestorObjs[i].id);
		allProps.sort(SortByName);
	
		function GetProperties(oID,classProperties){
			var ps=IterableFlavor(ExecuteSQL('sp_GetObjectProperties',oID,(classProperties==null)?null:classProperties*1),'id','name','readOnly','overview','objID','objName','langID','langPrefix','objTypeID','objTypeName','objTypeLangID','objTypeLangPrefix');
			allProps=allProps.concat(ps);
		}
	
		if (allProps.length){
			%>
			<h2>Instance Properties</h2>
			<table id="instance_properties" class="out" cellspacing="0">
				<thead><tr><th>name</th><th>type</th><th class="last">description</th></tr></thead>
				<tbody><%
					for (var i=0,len=allProps.length;i<len;i++){
						var p=allProps[i];
						var inherited = (p.objID!=objID);
						Response.Write('<tr'+(inherited?' class="inherited"':'')+'><th><a href="property.asp?id='+p.id+'">'+p.name+'</a></th>');
						Response.Write('<td><a href="object.asp?id='+p.objTypeID+'">'+(p.objTypeLangID!=obj.langID?p.objTypeLangPrefix:'')+p.objTypeName+'</a></td>');
						Response.Write('<td class="last">'+(p.overview?(p.overview+' '):'')+(p.readOnly?'<span class="readonly">(read only)</span> ':'')+(inherited?('<span class="ancillary">[inherited from <a href="object.asp?id='+p.objID+'">'+(p.langID!=obj.langID?p.langPrefix:'')+p.objName+'</a>]</span>'):'')+'&nbsp;</td>');
					}
				%></tbody>
			</table>
			<%
		}

		var allMeths=[];
		GetMethods(objID,0);
		for (var i=0,len=ancestorObjs.length;i<len;i++) GetMethods(ancestorObjs[i].id,0);
		allMeths.sort(SortByName);

		function GetMethods(oID,classMethods){
			var ms=IterableFlavor(ExecuteSQL('sp_GetObjectMethods',oID,classMethods==null?null:classMethods),'id','name','overview','objID','objName','langID','langPrefix','returnTypeID','returnTypeName','returnTypeLangID','returnTypeLangPrefix');
			allMeths=allMeths.concat(ms);
		}

		if (allMeths.length){
			%>
			<h2>Instance Methods</h2>
			<table id="instance_methods" class="out" cellspacing="0">
				<thead><tr><th>name</th><th>returns</th><th class="last">description</th></tr></thead>
				<tbody><%
					for (var i=0,len=allMeths.length;i<len;i++){
						var m=allMeths[i];
						var inherited = (m.objID!=objID);
						Response.Write('<tr'+(inherited?' class="inherited"':'')+'><th><a href="method.asp?id='+m.id+'">'+m.name+'</a></th>');
						Response.Write('<td>'+(m.returnTypeID?('<a href="object.asp?id='+m.returnTypeID+'">'+(m.returnTypeLangID!=obj.langID?m.returnTypeLangPrefix:'')+m.returnTypeName+'</a>'):'<span class="ancillary">(none)</span>')+'</td>');
						Response.Write('<td class="last">'+(m.overview?(m.overview+' '):'')+(inherited?('<span class="ancillary">[from <a href="object.asp?id='+m.objID+'">'+(m.langID!=obj.langID?m.langPrefix:'')+m.objName+'</a>]</span>'):'')+'&nbsp;</td>');
					}
				%></tbody>
			</table>
			<%
		}

		var allConsts=IterableFlavor(ExecuteSQL('sp_GetObjectConstants',objID),'name','value','overview');

		if (allConsts.length>0) {
			%>
			<h2>Class Constants</h2>
			<table id="constants" class="out" cellspacing="0">
				<thead><tr><th>name</th><th>value</th><th class="last">description</th></tr></thead>
				<tbody><%
					for (var i=0,len=allConsts.length;i<len;i++){
						var c=allConsts[i];
						Response.Write('<tr><th>'+obj.name+'.'+c.name+'</th>');
						Response.Write('<td>'+c.value+'</td>');
						Response.Write('<td class="last">'+(c.overview?c.overview:'&nbsp;')+'</td>');
					}
				%></tbody>
			</table>
			<%
		}

	if (obj.description){
	%>
	<h2>Description</h2>
	<div id="description"><%
		if (obj.description.indexOf('<p>')==-1 && obj.description.indexOf('</p>')==-1) Response.Write('<p>'+Text2HTML(obj.description,false,false,true)+'</p>');
		else Response.Write(obj.description);
	%></div><%
	}
	%>

	<p id="seealso">See also: <a href="objectused.asp?id=<%=objID%>">Where is <%=obj.name%> used?</a></p>
<%AddLog(kEvent.pageView,null,obj.langID,objID)%>

<!-- #include file="includes/footer.asp" -->
