module Ramaze::Helper::EmailObfuscator
  def obfuscate_email( email )
    email.each_char.map do |char|
      if char=="@"
        rand(2)==0 ? "&#64;" : "%40"
      else
        case rand
          when 0.0...0.1
            "&##{char.ord};"
          when 0.1...0.2
            "%%%x" % char.ord
          else
            char
        end
      end
    end.join
  end  
end