<!-- #include file="../includes/functions.asp" -->
<!-- #include file="../includes/admin_auth.asp" -->
<%
	var pageTitle='Upload a New Language';
%>
<!-- #include file="../includes/admin_header.asp" -->
<script type="text/javascript">
var langInfo = {
<%
var allLangs = IterableFlavor(ExecuteSQL("SELECT langID,langName,url,prefix,copyright,directoryName,keywords,overview FROM t_Languages ORDER BY langName"),'id','name','url','prefix','copyright','dir','keys','oview');
for (var i=0,len=allLangs.length;i<len;i++){
	var lang=allLangs[i];
	%>'<%=lang.id%>':{name:'<%=lang.name.toJSString()%>',url:'<%=lang.url ? lang.url.toJSString() : ''%>',prefix:'<%=lang.prefix ? lang.prefix.toJSString() : ''%>',copy:'<%=lang.copyright ? lang.copyright.toJSString() : ''%>',dir:'<%=lang.dir.toJSString()%>',keys:'<%=lang.keys ? lang.keys.toJSString() : ''%>',oview:'<%=lang.oview ? lang.oview.toJSString() : ''%>'},
	<%
}
%>'z':'z'
};

function PrefillLanguage(f,langID){
	var lang = langInfo[langID] || {};
	f.elements.langName.value      = lang.name||'';
	f.elements.url.value           = lang.url||'';
	f.elements.prefix.value   	   = lang.prefix||'';
	f.elements.copyright.value     = lang.copy||'';
	f.elements.directoryName.value = lang.dir||'';
	f.elements.keywords.value      = lang.keys||'';
	f.elements.oview.value         = lang.oview||'';
}

AttachEvent(window,'load',function(){ document.getElementById('langID').focus() },false);
</script>
<form method="post" action="language_proc.asp" autovalidate="true" warnonunsavedchanges="true" enctype="multipart/form-data">
	<dl>
		<dt>Language</dt>
		<dd>
			<select id="langID" name="langID" onchange="PrefillLanguage(this.form,this.value)"><option value="">(new language)</option><%
				for (var i=0,len=allLangs.length;i<len;i++){
					var lang=allLangs[i];
					%><option value="<%=lang.id%>"><%=lang.name%></option><%
				}
			%></select>
		</dd>

		<dt><%=reqd%>Name</dt>
		<dd><input type="text" name="langName" nicename="Language Name" maxlength="50" required="true" size="30"></dd>

		<dt>Overview</dt>
		<dd><input type="text" name="oview" nicename="Overview" maxlength="200" size="50"></dd>

		<dt><%=reqd%>Directory</dt>
		<dd>
			<input type="text" name="directoryName" maxlength="50" size="20" required="true">
			<div class="formhelp">The name to use for the directory when creating a static version of ObjJob; must be unique among all languages.</div>
		</dd>

		<dt>Prefix</dt>
		<dd>
			<input type="text" name="prefix" maxlength="20" size="10">
			<div class="formhelp">Prefix to put in front of objects when referred to from other languages (including the trailing '::', e.g. 'dom::')</div>
		</dd>

		<dt>URL</dt>
		<dd>
			<input type="text" name="url" maxlength="200" size="50">
			<div class="formhelp">URL to the official specification for the entire language.</div>
		</dd>

		<dt>Keywords</dt>
		<dd>
			<input type="text" name="keywords" nicename="Keywords" maxlength="50" size="50">
			<div class="formhelp">Should be distinct from words existing in the name of the language.</div>
		</dd>

		<dt>Copyright</dt>
		<dd>
			<textarea name="copyright" nicename="Copyright" maxlength="1000" cols="70" rows="8"></textarea>
			<div class="formhelp">Will be appended to the bottom of every page for this language.</div>
		</dd>

		<dt>Objects CSV</dt>
		<dd><input type="file" name="csv_objects" nicename="Objects CSV"></dd>

		<dt>Hierarchy CSV</dt>
		<dd><input type="file" name="csv_hier" nicename="Hierarchy CSV"></dd>

		<dt>Constants CSV</dt>
		<dd><input type="file" name="csv_constants"></dd>

		<dt>Properties CSV</dt>
		<dd><input type="file" name="csv_properties"></dd>

		<dt>Methods CSV</dt>
		<dd><input type="file" name="csv_methods"></dd>



		<dt></dt>
		<dd class="submit"><button type="submit">Save Changes</button></dd>
	</dl>
</form>
<%AddLog(kEvent.pageView)%>
<!-- #include file="../includes/footer.asp" -->
