<!-- #include file="includes/functions.asp" -->
<%
	var objID=Request("id")();
	if (!objID) Response.Redirect('objects.asp');
	var obj=AssignProperties(ExecuteSQL('sp_GetObject',objID),'name','langID','overview','description','url');
	SetLanguage(obj.langID);

	var props = IterableFlavor(ExecuteSQL('sp_GetPropertiesOfType',objID),'id','name','overview','objID','objName','langID','langName','langPrefix');
	var meths = IterableFlavor(ExecuteSQL('sp_GetMethodsThatReturn',objID),'id','name','overview','objID','objName','langID','langName','langPrefix');
	var args  = IterableFlavor(ExecuteSQL('sp_GetArgumentsOfType',objID),'id','name','overview','methID','methName','objID','objName','langID','langName','langPrefix');

	AddLog(kEvent.pageView,null,obj.langID,objID);
	CloseConnection();

	var page='objects';
	var pageTitle='Where is <a href="object.asp?id='+objID+'">'+obj.name+'</a> used?';
	var indefArticle = (/^([aeiou]|SVG)/i).test(obj.name)?'an':'a';
%>
<!-- #include file="includes/header.asp" -->
	<h2>Object classes that inherit from <%=obj.name%></h2>
	<%
		if (!WriteHierarchy(objID,null,0)) Response.Write('<p class="ancillary">(no classes inherit from this object type)</p>\n');
	%>

	<h2>Properties that are <%=indefArticle+' '+obj.name%></h2>
		<%
		if (props.length==0) Response.Write('<p class="ancillary">(there are no properties of this object type)</p>\n');
		else {
			%>
			<table id="properties" class="out" cellspacing="0">
				<thead><tr><th>name</th><th>in object</th><th class="last">description</th></tr></thead>
				<tbody><%
					for (var i=0,len=props.length;i<len;i++){
						var p=props[i];
						Response.Write('<tr><th><a href="property.asp?id='+p.id+'">'+p.name+'</a></th>');
						Response.Write('<td><a href="object.asp?id='+p.objID+'">'+(p.langPrefix?p.langPrefix:'')+p.objName+'</a></td>');
						Response.Write('<td class="last">'+(p.overview?p.overview:'&nbsp;')+'</td></tr>');
					}
				%></tbody>
			</table><%
		}
		%>



	<h2>Methods that return <%=indefArticle+' '+obj.name%></h2>
		<%
		if (meths.length==0) Response.Write('<p class="ancillary">(there are no methods that return this object type)</p>\n');
		else {
			%>
			<table id="properties" class="out" cellspacing="0">
				<thead><tr><th>name</th><th>of object</th><th class="last">description</th></tr></thead>
				<tbody><%
					for (var i=0,len=meths.length;i<len;i++){
						var p=meths[i];
						Response.Write('<tr><th><a href="method.asp?id='+p.id+'">'+p.name+'</a></th>');
						Response.Write('<td><a href="object.asp?id='+p.objID+'">'+(p.langPrefix?p.langPrefix:'')+p.objName+'</a></td>');
						Response.Write('<td class="last">'+(p.overview?p.overview:'&nbsp;')+'</td></tr>');
					}
				%></tbody>
			</table><%
		}
		%>

	<h2>Arguments of type <%=obj.name%></h2>
		<%
		if (args.length==0) Response.Write('<p class="ancillary">(there are no arguments of this object type)</p>\n');
		else {
			%>
			<table id="properties" class="out" cellspacing="0">
				<thead><tr><th>name</th><th>in method</th><th>of object</th><th class="last">description</th></tr></thead>
				<tbody><%
					for (var i=0,len=args.length;i<len;i++){
						var p=args[i];
						Response.Write('<tr><th>'+p.name+'</th>');
						Response.Write('<td><a href="method.asp?id='+p.methID+'">'+p.methName+'</a></td>');
						Response.Write('<td><a href="object.asp?id='+p.objID+'">'+(p.langPrefix?p.langPrefix:'')+p.objName+'</a></td>');
						Response.Write('<td class="last">'+(p.overview?p.overview:'&nbsp;')+'</td></tr>');
					}
				%></tbody>
			</table><%
		}
		%>

<!-- #include file="includes/footer.asp" -->
